package com.company.untitled3.entity;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;

import javax.persistence.AttributeConverter;
import javax.persistence.Converter;

/**
 * User: Nurmuhammad
 * Date: 29/08/2022 19:40
 */
@Converter(autoApply = true)
public class JsonAttributeConverter implements AttributeConverter<Object, String> {

    private Gson jsonb = new GsonBuilder().setPrettyPrinting().create();

    @Override
    public String convertToDatabaseColumn(Object object) {
        if (object == null) return null;

        return jsonb.toJson(object);
    }

    @Override
    public Object convertToEntityAttribute(String value) {
        if (value == null) return null;

        return jsonb.fromJson(value, JsonPojo.class);
    }

}
