package com.company.untitled3.entity;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import io.jmix.core.metamodel.annotation.DatatypeDef;
import io.jmix.core.metamodel.annotation.Ddl;
import io.jmix.core.metamodel.datatype.Datatype;

import javax.annotation.Nullable;
import java.text.ParseException;
import java.util.Locale;

/**
 * User: Nurmuhammad
 * Date: 29/08/2022 22:03
 */
@DatatypeDef(
        id = "jsonPojo",
        javaClass = JsonPojo.class,
        defaultForClass = true, value = "core_JsonPojoDataType"
)
@Ddl("jsonb")
public class JsonPojoDataType implements Datatype<JsonPojo> {

    private Gson jsonb = new GsonBuilder().setPrettyPrinting().create();

    @Override
    public Class getJavaClass() {
        return JsonPojo.class;
    }

    @Override
    public String format(@Nullable Object value) {
        if (value == null) return null;

        return jsonb.toJson(value);
    }

    @Override
    public String format(@Nullable Object value, Locale locale) {
        if (value == null) return null;

        return jsonb.toJson(value);
    }

    @Nullable
    @Override
    public JsonPojo parse(@Nullable String value) throws ParseException {
        if (value == null) return null;

        return jsonb.fromJson(value, JsonPojo.class);
    }

    @Nullable
    @Override
    public JsonPojo parse(@Nullable String value, Locale locale) throws ParseException {
        if (value == null) return null;

        return jsonb.fromJson(value, JsonPojo.class);
    }
}
