package com.company.untitled3.listener;

import com.company.untitled3.entity.JsonPojo;
import com.company.untitled3.entity.Project;
import com.github.javafaker.Faker;
import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import io.jmix.core.DataManager;
import io.jmix.core.security.Authenticated;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.context.event.ApplicationStartedEvent;
import org.springframework.context.event.ContextRefreshedEvent;
import org.springframework.stereotype.Component;
import org.springframework.context.event.EventListener;

@Component
@Slf4j
public class AppLifecycleEventListener {

    @Autowired
    private DataManager dataManager;

    @Authenticated
    @EventListener
    public void onApplicationContextRefreshed(ContextRefreshedEvent event) {

        Faker faker = new Faker();

        long l = 1;
        do {
            Project project = dataManager.create(Project.class);
            project.setName(faker.funnyName().name() + " project");
            project.setData(JsonPojo.getNew(faker));
            dataManager.save(project);
            log.info("  " + l + ". " + project.getName() + " is saved.");
            l++;
        } while (l <= 1000);

    }
}
